import {EventTarget as $QdH60$EventTarget, Event as $QdH60$Event} from "event-target-shim";
import {parseHeaders as $QdH60$parseHeaders, parseBody as $QdH60$parseBody} from "koajax";
import {Headers as $QdH60$Headers, fetch as $QdH60$fetch, Blob as $QdH60$Blob} from "taro-fetch-polyfill";
import {ReadableStream as $QdH60$ReadableStream} from "web-streams-polyfill";
import {createAsyncIterator as $QdH60$createAsyncIterator} from "web-utility";


function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}





class $4746180c5a14f01a$export$863d066dc35784fb extends (0, $QdH60$Event) {
    constructor(type, { lengthComputable: lengthComputable, total: total, loaded: loaded, ...meta } = {}){
        super(type, meta);
        this.lengthComputable = lengthComputable;
        this.total = total;
        this.loaded = loaded;
    }
}
async function $4746180c5a14f01a$export$ad2db95f22033cc(iterableOrArrayLike) {
    if (typeof iterableOrArrayLike[Symbol.asyncIterator] !== 'function') iterableOrArrayLike = Array.from(iterableOrArrayLike);
    const result = [];
    for await (const item of iterableOrArrayLike)result.push(item);
    return result;
}


var $571b30dc9677e402$exports = {};

$parcel$export($571b30dc9677e402$exports, "streamFromProgress", function () { return $571b30dc9677e402$export$f8162fcba31fa547; });
$parcel$export($571b30dc9677e402$exports, "emitStreamProgress", function () { return $571b30dc9677e402$export$cebfdbc318a33abe; });


const $571b30dc9677e402$export$f8162fcba31fa547 = (target)=>(0, $QdH60$createAsyncIterator)(({ next: next, complete: complete, error: error })=>{
        const handleProgress = ({ loaded: loaded, total: total })=>{
            next({
                loaded: loaded,
                total: total
            });
            if (loaded >= total) complete();
        };
        target.addEventListener('progress', handleProgress);
        target.addEventListener('error', error);
        return ()=>{
            target.removeEventListener('progress', handleProgress);
            target.removeEventListener('error', error);
        };
    });
async function* $571b30dc9677e402$export$cebfdbc318a33abe(stream, total, eventTarget) {
    var loaded = 0;
    for await (const chunk of stream){
        yield chunk;
        loaded += chunk.byteLength;
        const event = new (0, $4746180c5a14f01a$export$863d066dc35784fb)('progress', {
            lengthComputable: isNaN(total),
            loaded: loaded,
            total: total
        });
        eventTarget.dispatchEvent(event);
    }
}


function $9dc83072d0d4ec0f$export$b5fe3f66a567bec0({ path: path, method: method, headers: headers, withCredentials: withCredentials, body: body, signal: signal, timeout: timeout, responseType: responseType }) {
    const signals = [
        signal,
        timeout && AbortSignal.timeout(timeout)
    ].filter(Boolean);
    headers = headers instanceof (0, $QdH60$Headers) ? Object.fromEntries(headers.entries()) : headers instanceof Array ? Object.fromEntries(headers) : headers;
    headers = responseType === 'text' ? {
        ...headers,
        Accept: 'text/plain'
    } : responseType === 'json' ? {
        ...headers,
        Accept: 'application/json'
    } : responseType === 'document' ? {
        ...headers,
        Accept: 'text/html, application/xhtml+xml, application/xml'
    } : responseType === 'arraybuffer' || responseType === 'blob' ? {
        ...headers,
        Accept: 'application/octet-stream'
    } : headers;
    const isStream = body instanceof (0, $QdH60$ReadableStream);
    var upload;
    if (isStream) {
        const uploadProgress = new (0, $QdH60$EventTarget)();
        body = (0, $QdH60$ReadableStream).from((0, $571b30dc9677e402$export$cebfdbc318a33abe)(body, +headers['Content-Length'], uploadProgress));
        upload = (0, $571b30dc9677e402$export$f8162fcba31fa547)(uploadProgress);
    }
    const downloadProgress = new (0, $QdH60$EventTarget)();
    const response = (0, $QdH60$fetch)(path + '', {
        method: method,
        headers: headers,
        credentials: withCredentials ? 'include' : 'omit',
        body: body,
        signal: signals[0] && AbortSignal.any(signals),
        // @ts-expect-error https://developer.chrome.com/docs/capabilities/web-apis/fetch-streaming-requests
        duplex: isStream ? 'half' : undefined
    }).then((response)=>$9dc83072d0d4ec0f$export$ba14d9a5a581e827(response, responseType, downloadProgress));
    return {
        response: response,
        upload: upload,
        download: (0, $571b30dc9677e402$export$f8162fcba31fa547)(downloadProgress)
    };
}
async function $9dc83072d0d4ec0f$export$ba14d9a5a581e827({ status: status, statusText: statusText, headers: headers, body: body }, responseType, downloadProgress) {
    const stream = (0, $QdH60$ReadableStream).from((0, $571b30dc9677e402$export$cebfdbc318a33abe)(body, +headers.get('Content-Length'), downloadProgress));
    const contentType = headers.get('Content-Type') || '';
    const header = (0, $QdH60$parseHeaders)([
        ...headers
    ].map(([key, value])=>`${key}: ${value}`).join('\n'));
    const rBody = status === 204 ? undefined : await $9dc83072d0d4ec0f$export$b7b86d31099674dc(stream, contentType, responseType);
    return {
        status: status,
        statusText: statusText,
        headers: header,
        body: rBody
    };
}
async function $9dc83072d0d4ec0f$export$b7b86d31099674dc(stream, contentType, responseType) {
    const blob = new (0, $QdH60$Blob)(await (0, $4746180c5a14f01a$export$ad2db95f22033cc)(stream), {
        type: contentType
    });
    if (responseType === 'blob') return blob;
    if (responseType === 'arraybuffer') return blob.arrayBuffer();
    const text = await blob.text();
    if (responseType === 'text') return text;
    return (0, $QdH60$parseBody)(text, contentType);
}


export {$9dc83072d0d4ec0f$export$b5fe3f66a567bec0 as request, $9dc83072d0d4ec0f$export$ba14d9a5a581e827 as parseResponse, $9dc83072d0d4ec0f$export$b7b86d31099674dc as parseFetchBody, $571b30dc9677e402$export$f8162fcba31fa547 as streamFromProgress, $571b30dc9677e402$export$cebfdbc318a33abe as emitStreamProgress};
//# sourceMappingURL=index.esm.js.map
